ZAP    ; zap/asm
 @DISPLY	EQU	4467H
 @KEYIN	EQU	40H
 @KEY	EQU	49H
 @CKDRV3	EQU	4290H
 @CKDRV1	EQU	44B8H
 @WRSYS	EQU	4768H
 @WRSEC	EQU	4763H
 @POSN	EQU	4442H
 @READ	EQU	4436H
 @WRITE	EQU	4439H
 @FSPEC	EQU	441CH
 @RDSEC	EQU	4777H
 @OPEN	EQU	4424H
 @LOF3	EQU	4470H
 @LOF1	EQU	445DH
 @DSP	EQU	33H
 @KBD	EQU	2BH
 @ERROR	EQU	4409H
 @EXIT	EQU	402DH
 @ABORT	EQU	4030H
 @GETDCT	EQU	478FH
 	ORG	5200H
 ENTRY	PUSH	HL
 	LD	HL,HELLO
 	CALL	@DISPLY
 	POP	HL
 	JR	SCAN
 RESTART	LD	HL,STRING
 	LD	(HL),0DH
 	JR	ENTRY
 SCAN	CALL	POSHL
 	JP	C,ASKPARAMS
 	CP	'?'
 	JR	NZ,CNTSCN
 	PUSH	HL
 	LD	HL,WHO
 	CALL	@DISPLY
 	POP	HL
 	INC	HL
 	JR	SCAN
 CNTSCN	CP	':'
 	JR	Z,ZAPDRV
 	CP	'!'
 	JR	Z,ZAPFIL-1
 	PUSH	HL
 	CALL	VALUE
 	POP	HL
 	JR	C,ZAPFIL
 	LD	(ADDRESS),BC
 	LD	A,1
 	LD	(TYPE),A
 	JP	CONTINUE1
 ZAPDRV	INC	HL
 	LD	A,(HL)
 	SUB	30H
 	JP	C,PARAMERR
 	CP	8
 	JP	NC,PARAMERR
 	LD	(DRIVE),A
 	INC	HL
 	XOR	A
 	LD	(TRACK),A
 	LD	(SECTOR),A
 	CALL	POSHL
 	JR	C,ZAPDGO
 	CALL	VALUE
 	JR	C,PARAMERR
 	LD	A,C
 	LD	(TRACK),A
 	CALL	POSHL
 	JR	C,ZAPDGO
 	CALL	VALUE
 	JR	C,PARAMERR
 	LD	A,C
 	LD	(SECTOR),A
 ZAPDGO	LD	A,2
 	LD	(TYPE),A
 	JP	CONTINUE2
 NEWFILE	LD	HL,FILMSG
 	CALL	@DISPLY
 	LD	B,31
 	LD	HL,STRING
 	CALL	@KEYIN
 	JP	C,EXIT
 	LD	A,B
 	OR	A
 	JP	Z,RESTART
 	DEC	HL
 	INC	HL
 ZAPFIL	LD	DE,@FCB
 	CALL	@FSPEC
 	JP	NZ,ERROR
 	LD	HL,@FCB
 	LD	DE,FILNAME
 	LD	BC,30
 	LDIR
 	LD	DE,@FCB
 	LD	HL,@BUFFER
 	LD	B,0
 	CALL	@OPEN
 	JP	NZ,ERROR
 	LD	A,(@FCB+1)
 	AND	0F8H
 	LD	(@FCB+1),A
 	LD	A,3
 	LD	(TYPE),A
 	LD	HL,0
 	LD	(POSIT),HL
 	XOR	A
 	LD	(FLAGF),A
 	JP	CONTINUE3
 ERROR	PUSH	AF
 	CALL	SYSMOUNT
 	POP	AF
 	OR	0C0H
 	CALL	@ERROR
 	JR	ASKPARAMS
 PARAMERR	LD	HL,PARMSG
 	CALL	@DISPLY
 ASKPARAMS
 	LD	HL,DRVMSG
 	CALL	@DISPLY
 	LD	B,31
 	LD	HL,STRING
 	CALL	@KEYIN
 	JR	C,EXIT
 	LD	A,B
 	OR	A
 	JP	NZ,SCAN
 	LD	HL,HELP1
 	CALL	@DISPLY
 	JR	ASKPARAMS
 EXIT	LD	HL,EXMSG
 	CALL	@DISPLY
 	CALL	SYSMOUNT
 	JP	@EXIT
 	INC	HL
 POSHL	LD	A,(HL)
 	CP	13
 	SCF
 	RET	Z
 	CP	1
 	SCF
 	RET	Z
 	CP	20H
 	JR	Z,POSHL-1
 	CP	','
 	JR	Z,POSHL-1
 	OR	A
 	RET
 VALUE	EX	DE,HL
 	LD	BC,ADDHEX
 	LD	(VALCAL1),BC
 	LD	BC,CONVH
 	LD	(VALCAL2),BC
 	LD	A,(DE)
 	CALL	UCASE
 	CP	'H'
 	JR	Z,VALDOIT-1
 	LD	BC,ADDOCT
 	LD	(VALCAL1),BC
 	LD	BC,CONVO
 	LD	(VALCAL2),BC
 	CP	'O'
 	JR	Z,VALDOIT-1
 	LD	BC,ADDBIN
 	LD	(VALCAL1),BC
 	LD	BC,CONVB
 	LD	(VALCAL2),BC
 	CP	'B'
 	JR	Z,VALDOIT-1
 	LD	BC,ADDDEC
 	LD	(VALCAL1),BC
 	LD	BC,CONVD
 	LD	(VALCAL2),BC
 	CP	'D'
 	JR	NZ,VALDOIT
 	INC	DE
 VALDOIT	LD	BC,0
 VALLP	LD	A,(DE)
 	CP	13
 	JR	Z,VALDN+1
 	CP	','
 	JR	Z,VALDN
 	CP	20H
 	JR	Z,VALDN
 	CALL	UCASE
 	CALL	0
 VALCAL2	EQU	$-2
 	RET	C
 	LD	H,B
 	LD	L,C
 	CALL	0
 VALCAL1	EQU	$-2
 	LD	C,A
 	LD	B,0
 	ADD	HL,BC
 	LD	B,H
 	LD	C,L
 	INC	DE
 	JR	VALLP
 VALDN	INC	DE
 	EX	DE,HL
 	RET
 ADDDEC	ADD	HL,HL
 	ADD	HL,HL
 	ADD	HL,BC
 	ADD	HL,HL
 	RET
 ADDHEX	ADD	HL,HL
 	ADD	HL,HL
 	ADD	HL,HL
 	ADD	HL,HL
 	RET
 ADDBIN	ADD	HL,HL
 	RET
 ADDOCT	ADD	HL,HL
 	ADD	HL,HL
 	ADD	HL,HL
 	RET
 CONVD	SUB	30H
 	RET	C
 	CP	10
 	CCF
 	RET
 CONVH	SUB	30H
 	RET	C
 	CP	10
 	CCF
 	RET	NC
 	SUB	7
 	RET	C
 	CP	16
 	CCF
 	RET
 CONVB	SUB	30H
 	RET	C
 	CP	2
 	CCF
 	RET
 CONVO	SUB	30H
 	RET	C
 	CP	8
 	CCF
 	RET
 BADWRT	PUSH	HL
 	LD	HL,BADWMSG
 	JR	DOBAD
 BADRD	PUSH	HL
 	LD	HL,BADRMSG
 DOBAD	LD	(ERNO),A
 	PUSH	DE
 	PUSH	BC
 	CALL	@DISPLY
 	LD	A,9
 DRIVE	EQU	$-1
 	OR	A
 	JR	Z,GETBAD
 	LD	A,0
 ERNO	EQU	$-1
 	OR	0C0H
 	CALL	@ERROR
 GETBAD	LD	HL,ASKBAD
 	CALL	@DISPLY
 	LD	B,1
 	LD	HL,STRING
 	CALL	@KEYIN
 	JP	C,EXIT
 	LD	A,(HL)
 	CALL	UCASE
 	CP	'S'
 	JR	Z,BADRET
 	CP	'R'
 	JR	NZ,GETBAD
 	OR	1
 BADRET	PUSH	AF
 	CALL	1C9H
 	POP	AF
 	POP	BC
 	POP	DE
 	POP	HL
 	RET
 ASCII	PUSH	HL
 	CALL	ASCI
 	LD	H,B
 	PUSH	HL
 	LD	A,C
 	SUB	30H
 	CALL	ASCI
 	LD	A,C
 	CP	'0'
 	JR	NZ,ASCIGO1
 	LD	A,20H
 ASCIGO1	POP	HL
 	LD	C,B
 	LD	B,H
 	POP	HL
 	RET
 ASCI	LD	C,'0'
 ASCII1	SUB	10
 	JR	C,ASCII2
 	INC	C
 	JR	ASCII1
 ASCII2	ADD	A,3AH
 	LD	B,A
 	RET
 UCASE	CP	60H
 	RET	C
 	CP	80H
 	RET	NC
 	AND	5FH
 	RET
 DESMOUNT
 	LD	HL,DMTMSG
 	JR	SYSMOUNT+3
 SYSMOUNT
 	LD	HL,SMTMSG
 	LD	A,(DRIVE)
 	OR	A
 	RET	NZ
 	PUSH	HL
 	PUSH	IY
 	LD	A,10
 	CALL	@DSP
 	POP	IY
 	POP	HL
 	EXX
 	LD	HL,CLRLIN
 	EXX
 	LD	BC,200H
 SYSLP	CALL	@DISPLY
 	PUSH	BC
 	CALL	@KBD
 	POP	BC
 	CP	13
 	JR	Z,MNTDON
 	CP	1
 	JP	Z,EXIT
 	DEC	BC
 	LD	A,B
 	OR	A
 	JR	NZ,SYSLP+3
 	EXX
 	JR	SYSLP-3
 MNTDON	PUSH	IY
 	LD	A,10
 	CALL	@DSP
 	POP	IY
 	RET
 DISPLY	PUSH	IX
 	PUSH	IY
 	PUSH	DE
 	CALL	@DISPLY
 	POP	DE
 	POP	IY
 	POP	IX
 	RET
 KBD	PUSH	IY
 	PUSH	DE
 	PUSH	IX
 	CALL	@KBD
 	POP	IX
 	POP	DE
 	POP	IY
 	RET
 @VID	PUSH	IY
 	PUSH	DE
 	CALL	@DSP
 	POP	DE
 	POP	IY
 	RET
 NEXSEC	INC	E
 	LD	A,(IY+7)
 	AND	1FH
 	INC	A
 	BIT	5,(IY+4)
 	JR	Z,NEXS
 	SLA	A
 NEXS	SUB	E
 	RET	NZ
 	LD	E,A
 	LD	A,D
 	CP	(IY+6)
 	RET	Z
 	INC	D
 	RET
 BAKSEC	LD	A,E
 	OR	A
 	JR	Z,BADEND
 	DEC	E
 	RET
 BADEND	LD	A,D
 	OR	A
 	RET	Z
 	LD	A,(IY+7)
 	AND	1FH
 	LD	E,A
 	DEC	D
 	RET
 HEXCV	LD	B,A
 	SRL	A
 	SRL	A
 	SRL	A
 	SRL	A
 	CALL	HEXTST
 	LD	C,A
 	LD	A,B
 	AND	0FH
 	CALL	HEXTST
 	LD	B,A
 	RET
 HEXTST	ADD	A,30H
 	CP	3AH
 	RET	M
 	ADD	A,7
 	RET
 WRLNO	LD	DE,TENTBL
 A4B7B	LD	A,(DE)
 	LD	C,A
 	INC	DE
 	LD	A,(DE)
 	LD	B,A
 	INC	DE
 	PUSH	DE
 	LD	A,2FH
 A4B84	INC	A
 	LD	D,H
 	LD	E,L
 	ADD	HL,BC
 	JR	C,A4B84
 	EX	DE,HL
 	POP	DE
 	LD	(IX),A
 	INC	IX
 	INC	C
 	JR	NZ,A4B7B
 	RET
 TENTBL	DW	-10000,-1000,-100,-10,-1
 CONTINUE1	CALL	1C9H
 	LD	HL,CONTMEM
 	LD	(VECTOR),HL
 CONTMEM	CALL	SHOW
 	CALL	FLKEY
 	CP	1
 	JP	Z,EXIT
 	LD	DE,TABLE1
 	LD	BC,(ADDRESS)
 	LD	HL,0
 VECTOR	EQU	$-2
 	CALL	GOTABLE
 	JR	CONTMEM
 TABLE1	DB	5BH
 	DW	DMEMUP
 	DB	'X'
 	DW	RESTART
 	DB	10
 	DW	DMEMDP
 	DB	8
 	DW	DMEMD
 	DB	9
 	DW	DMEMU
 	DB	18H
 	DW	DMEMDP
 	DB	19H
 	DW	DMEMUP
 	DB	1AH
 	DW	DMEMB
 	DB	1BH
 	DW	DMEMT
 	DB	'A'
 	DW	ASCIT
 	DB	'B'
 	DW	BINIT
 	DB	'D'
 	DW	DECIT
 	DB	'H'
 	DW	HEXIT
 	DB	'O'
 	DW	OCTIT
 	DB	'M'
 	DW	MODIFY
 	DB	31
 	DW	NEWDISMEM
 	DB	0
 DMEMU	INC	BC
 	JR	DISMRET
 DMEMD	DEC	BC
 	JR	DISMRET
 DMEMUP	INC	B
 	JR	DISMRET
 DMEMT	LD	A,(4)
 	CP	30H
 	LD	BC,(4411H)
 	JR	Z,DISMRET
 	LD	BC,(4049H)
 	JR	DISMRET
 DMEMDP	DEC	B
 	JR	DISMRET
 DMEMB	LD	BC,0
 DISMRET	LD	(ADDRESS),BC
 	JP	(HL)
 NEWDISMEM	LD	HL,NEWADD
 	CALL	DISPLY
 	LD	HL,STRING
 	LD	B,31
 	CALL	@KEYIN
 	JP	C,EXIT
 	LD	A,B
 	OR	A
 	JP	Z,RESTART
 	CALL	VALUE
 	JR	C,NEWDISMEM
 	LD	(ADDRESS),BC
 	JP	CONTINUE1
 FLKEY	LD	HL,3C00H
 	LD	(4020H),HL
 	LD	HL,2020H
 	LD	(3C01H),HL
 	LD	A,14
 	PUSH	IY
 	CALL	@DSP
 	POP	IY
 	CALL	@KEY
 	LD	HL,(4020H)
 	CALL	UCASE
 	PUSH	AF
 	LD	A,15
 	PUSH	IY
 	CALL	@DSP
 	POP	IY
 	POP	AF
 	LD	(HL),A
 	CP	20H
 	RET	NC
 	LD	(HL),143
 	RET
 SHOW	LD	IX,0
 ADDRESS	EQU	$-2
 	LD	IY,3C00H+8
 	LD	C,16
 SHOWLP	PUSH	BC
 	PUSH	IY
 	PUSH	IX
 	LD	L,8
 SHOWPL1	LD	H,2
 SHOWPL	LD	A,(IX)
 	CALL	HEXCV
 	LD	(IY),C
 	INC	IY
 	LD	(IY),B
 	INC	IY
 	INC	IX
 	DEC	H
 	JR	NZ,SHOWPL
 	INC	IY
 	DEC	L
 	JR	NZ,SHOWPL1
 	POP	IX
 	LD	B,16
 	LD	(IY-1),149
 SHOWPP	LD	A,(IX)
 	CP	20H
 	JR	NC,N0N0
 	LD	A,'.'
 N0N0	LD	(IY),A
 	CP	(IY)
 	JR	Z,SHCCC
 	SUB	20H
 	LD	(IY),A
 SHCCC	INC	IY
 	INC	IX
 	DJNZ	SHOWPP
 	POP	IY
 	LD	DE,40H
 	ADD	IY,DE
 	POP	BC
 	DEC	C
 	JR	NZ,SHOWLP
 	CALL	SHOWMODE
 	LD	A,0
 TYPE	EQU	$-1
 	CP	1
 	JP	Z,SHOWNUM
 	LD	A,(ADDRESS)
 	LD	IY,3C05H
 NBLP	PUSH	AF
 	CALL	HEXCV
 	LD	(IY),C
 	LD	(IY+1),B
 	LD	(IY+2),170
 	LD	BC,40H
 	ADD	IY,BC
 	POP	AF
 	ADD	A,16
 	JR	NZ,NBLP
 	LD	IY,(IYSAVE)
 	LD	A,(TYPE)
 	CP	3
 	JP	Z,SHOWFILE
 	LD	HL,DVMSG
 	LD	DE,3C00H+128
 	LD	BC,3
 	LDIR
 	LD	A,(DRIVE)
 	ADD	A,30H
 	LD	(3C00H+193),A
 	LD	HL,CYLMSG
 	LD	DE,3C00H+256
 	LD	BC,3
 	LDIR
 	LD	A,(TRACK)
 	CALL	ASCII
 	LD	(3C00H+320),A
 	LD	(3C00H+321),BC
 	LD	HL,SIDMSG
 	LD	DE,3C00H+384
 	LD	BC,3
 	LDIR
 	LD	A,'0'
 	BIT	4,(IY+3)
 	JR	Z,GTSD
 	INC	A
 GTSD	LD	(3C00H+450),A
 	LD	HL,SECMSG
 	LD	DE,3C00H+512
 	LD	BC,3
 	LDIR
 	LD	A,(SECTOR)
 	CALL	ASCII
 	LD	(3C00H+576),A
 	LD	(3C00H+577),BC
 	LD	HL,RPTMSG
 	LD	DE,3C00H+640
 	LD	BC,3
 	LD	A,(RDTYP)
 	CP	6
 	JR	Z,GOTTP
 	LD	HL,DELMSG
 	CP	7
 	JR	Z,GOTTP
 	LD	HL,STDMSG
 GOTTP	LDIR
 	LD	A,'8'
 	BIT	5,(IY+3)
 	JR	NZ,GOTSIZ
 	LD	A,'5'
 GOTSIZ	LD	(3C00H+705),A
 	LD	A,'"'
 	LD	(3C00H+706),A
 	LD	HL,FLPMSG
 	LD	DE,3C00H+768
 	LD	BC,3
 	BIT	3,(IY+3)
 	JR	Z,GOTFLP
 	LD	HL,HRDMSG
 GOTFLP	LDIR
 	LD	A,'S'
 	BIT	6,(IY+3)
 	JR	Z,GOTDN
 	LD	A,'D'
 GOTDN	LD	(3C00H+833),A
 	LD	A,'D'
 	LD	(3C00H+834),A
 	LD	A,'S'
 	BIT	5,(IY+4)
 	JR	Z,GOTSD
 	LD	A,'D'
 GOTSD	LD	(3C00H+897),A
 	LD	A,'S'
 	LD	(3C00H+898),A
 	BIT	7,(IY+3)
 	RET	Z
 	LD	HL,WPMSG
 	LD	DE,3C00H+960
 	LD	BC,3
 	LDIR
 	RET
 SHOWFILE	LD	HL,3C04H
 	LD	DE,FILNAME
 	LD	BC,40H
 	LD	A,16
 SHOWFL1	PUSH	AF
 	LD	A,(DE)
 	INC	DE
 	CP	':'
 	JR	Z,SHOWFL2
 	CP	3
 	JR	Z,SHOWFL2
 	CP	13
 	JR	Z,SHOWFL2
 	OR	A
 	JR	Z,SHOWFL2
 	LD	(HL),A
 	ADD	HL,BC
 	POP	AF
 	DEC	A
 	JR	NZ,SHOWFL1
 	PUSH	AF
 SHOWFL2	POP	AF
 	LD	HL,DVMSG
 	LD	DE,3C00H+128
 	LD	BC,3
 	LDIR
 	LD	IX,@FCB
 	LD	A,(IX+6)
 	ADD	A,30H
 	LD	(3C00H+193),A
 	LD	HL,RELMSG
 	LD	DE,3C00H+768
 	LD	BC,4
 	LDIR
 	LD	IX,3C00H+831
 	LD	A,(IX)
 	PUSH	AF
 	LD	HL,(POSIT)
 	CALL	WRLNO
 	POP	AF
 	LD	(3C00H+831),A
 	LD	HL,EOFMSG
 	LD	DE,3C00H+896
 	LD	BC,4
 	LDIR
 	LD	IX,3C00H+959
 	LD	A,(IX)
 	PUSH	AF
 	LD	HL,(EOF)
 	CALL	WRLNO
 	POP	AF
 	LD	(3C00H+959),A
 	RET
 SHOWNUM	LD	HL,MEMMSG
 	LD	DE,3C80H
 	LD	BC,3
 	LDIR
 	LD	HL,(ADDRESS)
 	LD	DE,40H
 	LD	IY,3C00H+3
 	LD	A,16
 SHOWNUML	PUSH	AF
 	LD	A,H
 	CALL	HEXCV
 	LD	(IY),C
 	LD	(IY+1),B
 	LD	A,L
 	CALL	HEXCV
 	LD	(IY+2),C
 	LD	(IY+3),B
 	LD	(IY+4),170
 	ADD	IY,DE
 	POP	AF
 	LD	BC,10H
 	ADD	HL,BC
 	DEC	A
 	JR	NZ,SHOWNUML
 	RET
 MEMMSG	DB	'MEM'
 SHOWMODE	LD	A,0
 MODE	EQU	$-1
 	LD	B,A
 	SLA	A
 	ADD	A,B
 	LD	C,A
 	LD	B,0
 	LD	HL,MODTYP
 	ADD	HL,BC
 	PUSH	DE
 	LD	DE,3C40H
 	LD	BC,3
 	LDIR
 	POP	DE
 	RET
 MODTYP	DB	'HEXDECBINOCTASC'
 GOTABLE	PUSH	BC
 	PUSH	DE
 	PUSH	AF
 	EX	AF,AF'
 	POP	AF
 	CALL	UCASE
 	LD	C,A
 TABLP	LD	A,(DE)
 	OR	A
 	JR	Z,NOTINT
 	CP	C
 	JR	Z,HAVTAB
 	INC	DE
 	INC	DE
 	INC	DE
 	JR	TABLP
 NOTINT	EX	AF,AF'
 	POP	DE
 	POP	BC
 	RET
 HAVTAB	EX	(SP),HL
 	EX	DE,HL
 	INC	HL
 	LD	A,(HL)
 	INC	HL
 	LD	H,(HL)
 	LD	L,A
 	POP	AF
 	POP	BC
 	EX	(SP),HL
 	PUSH	AF
 	POP	HL
 	RET
 MODIFY	PUSH	HL
 	LD	IX,3C00H+8
 	LD	IY,3C00H+48
 	LD	DE,(ADDRESS)
 	LD	A,8FH
 	LD	(CRTPE),A
 MODWT	PUSH	DE
 	LD	HL,(ADDRESS)
 	EX	DE,HL
 	OR	A
 	SBC	HL,DE
 	LD	A,L
 	LD	(TEMP2),A
 	PUSH	BC
 	CALL	HEXCV
 	LD	(3C00H),BC
 	LD	A,5DH
 	LD	(3C00H+2),A
 	POP	BC
 	POP	DE
 MODWTXXX
 	LD	A,(CRTPE)
 	LD	(IX),A
 	LD	(IX+1),A
 	LD	(IY),A
 MOXLX	LD	A,40
 	LD	(MODCT),A
 MODLP	CALL	KBD
 	JR	NZ,MODGOT
 	LD	A,0
 MODCT	EQU	$-1
 	DEC	A
 	LD	(MODCT),A
 	JR	NZ,MODLP
 	LD	A,0
 CRTPE	EQU	$-1
 	CP	(IX)
 	JR	NZ,MODWTXXX
 	CALL	MODFIX
 	JR	MOXLX
 MODFIX	LD	A,(DE)
 	CALL	HEXCV
 	LD	(IX),C
 	LD	(IX+1),B
 	LD	A,(DE)
 	CP	20H
 	JR	NC,M0M0
 	LD	A,'.'
 M0M0	LD	(IY),A
 	CP	(IY)
 	RET	Z
 	SUB	20H
 	LD	(IY),A
 	RET
 MODGOT	PUSH	AF
 	CALL	MODFIX
 	POP	AF
 	CP	1
 	JP	Z,CANCEL
 	EX	DE,HL
 	LD	DE,MODWT
 	PUSH	DE
 	PUSH	AF
 	LD	A,(MODE)
 	CP	4
 	JR	Z,MODCONT
 	POP	AF
 	CP	'P'
 	JP	Z,FILLBYTES
 	CP	'p'
 	JP	Z,FILLBYTES
 	CP	'G'
 	JP	Z,GOBYTE
 	CP	'g'
 	JP	Z,GOBYTE
 	CP	'L'
 	JP	Z,FINDBYTE
 	CP	'l'
 	JP	Z,FINDBYTE
 	CP	'>'
 	JP	Z,INSBYTE
 	CP	'<'
 	JP	Z,DELBYTE
 	PUSH	AF
 MODCONT	POP	AF
 	LD	DE,MODTBL
 	CALL	GOTABLE
 	JP	NUMBER
 MODTBL	DB	8
 	DW	MODL
 	DB	9
 	DW	MODR
 	DB	5BH
 	DW	MODU
 	DB	10
 	DW	MODD
 	DB	19H
 	DW	MODRE
 	DB	18H
 	DW	MODLE
 	DB	1AH
 	DW	MODDE
 	DB	1BH
 	DW	MODUE
 	DB	31
 	DW	MODTOP
 	DB	13
 	DW	UPDATE
 	DB	13+80H
 	DW	CHWT
 	DB	0
 BLKS	DB	8FH,8FH,8FH
 CHWT	EX	DE,HL
 CHWT1	LD	HL,BLKS
 CHWT2	PUSH	DE
 	LD	DE,3C40H
 	LD	BC,3
 	LDIR
 	POP	DE
 	LD	A,12
 	LD	(CHWT4),A
 CHWT3	CALL	KBD
 	JR	NZ,CHWT5
 	LD	A,0
 CHWT4	EQU	$-1
 	DEC	A
 	LD	(CHWT4),A
 	JR	NZ,CHWT3
 	LD	A,(3C40H)
 	CP	8FH
 	JR	NZ,CHWT1
 	LD	HL,SPACES
 	JR	CHWT2
 CHWT5	CALL	UCASE
 	CP	'H'
 	LD	B,0
 	JR	Z,CHAVE
 	INC	B
 	CP	'D'
 	JR	Z,CHAVE
 	INC	B
 	CP	'B'
 	JR	Z,CHAVE
 	INC	B
 	CP	'O'
 	JR	Z,CHAVE
 	INC	B
 	CP	'A'
 	JR	NZ,CHAVE1
 CHAVE	LD	A,B
 	LD	(MODE),A
 CHAVE1	JP	SHOWMODE
 SPACES	DB	'                '
 MODR	EX	DE,HL
 	CALL	MODRX
 	RET	NC
 	CALL	MODDX
 	JR	NC,MODLE+1
 MODRCONT	LD	A,(TYPE)
 	CP	1
 	SCF
 	RET	NZ
 	LD	HL,(ADDRESS)
 	LD	BC,16
 	ADD	HL,BC
 	LD	(ADDRESS),HL
 	EX	DE,HL
 	ADD	HL,BC
 	EX	DE,HL
 	CALL	AASHOW
 	JP	MODLE+1
 MODTOP	EX	DE,HL
 	LD	A,0
 TEMP2	EQU	$-1
 	LD	B,A
 	OR	A
 	RET	Z
 MODTOPL	PUSH	BC
 	CALL	MODL+1
 	POP	BC
 	DJNZ	MODTOPL
 	RET
 MODRX	PUSH	IX
 	POP	HL
 	LD	A,L
 	AND	3FH
 	CP	2DH
 	SCF
 	RET	Z
 	INC	IX
 	INC	IX
 	INC	IY
 	INC	DE
 	LD	A,(IX)
 	CP	20H
 	SCF
 	CCF
 	RET	NZ
 	INC	IX
 	RET
 MODRE	EX	DE,HL
 	LD	A,16
 MODREX	EX	AF,AF'
 	CALL	MODRX
 	EX	AF,AF'
 	DEC	A
 	JR	NZ,MODREX
 	RET
 MODL	EX	DE,HL
 	CALL	MODLX
 	RET	NC
 	CALL	MODUX
 	JR	NC,MODRE+1
 MODLCONT	LD	A,(TYPE)
 	CP	1
 	SCF
 	RET	NZ
 	LD	HL,(ADDRESS)
 	LD	BC,16
 	OR	A
 	SBC	HL,BC
 	LD	(ADDRESS),HL
 	EX	DE,HL
 	OR	A
 	SBC	HL,BC
 	EX	DE,HL
 	CALL	AASHOW
 	JP	MODRE+1
 MODLE	EX	DE,HL
 	LD	A,16
 MODLEX	EX	AF,AF'
 	CALL	MODLX
 	EX	AF,AF'
 	DEC	A
 	JR	NZ,MODLEX
 	RET
 MODLX	PUSH	IX
 	POP	HL
 	LD	A,L
 	AND	3FH
 	CP	8
 	SCF
 	RET	Z
 	DEC	IX
 	DEC	IX
 	DEC	IY
 	DEC	DE
 	LD	A,(IX+1)
 	CP	20H
 	SCF
 	CCF
 	RET	NZ
 	DEC	IX
 	RET
 MODU	EX	DE,HL
 	CALL	MODUX
 	RET	NC
 	JP	MODLCONT
 MODUE	EX	DE,HL
 	LD	A,16
 MODUEX	EX	AF,AF'
 	CALL	MODUX
 	EX	AF,AF'
 	DEC	A
 	JR	NZ,MODUEX
 	RET
 MODUX	PUSH	IX
 	POP	HL
 	LD	BC,-40H
 	ADD	HL,BC
 	LD	A,H
 	CP	3CH
 	JR	C,MY
 	PUSH	HL
 	POP	IX
 	EX	DE,HL
 	LD	DE,-16
 	ADD	HL,DE
 	EX	DE,HL
 	PUSH	IY
 	POP	HL
 	LD	BC,-40H
 	ADD	HL,BC
 	PUSH	HL
 	POP	IY
 	OR	A
 	RET
 MODD	EX	DE,HL
 	CALL	MODDX
 	RET	NC
 	JP	MODRCONT
 MODDE	EX	DE,HL
 	LD	A,16
 MODDEX	EX	AF,AF'
 	CALL	MODDX
 	EX	AF,AF'
 	DEC	A
 	JR	NZ,MODDEX
 	RET
 MODDX	PUSH	IX
 	POP	HL
 	LD	BC,40H
 	ADD	HL,BC
 	LD	A,H
 	CP	40H
 	CCF
 	RET	C
 	PUSH	HL
 	POP	IX
 	EX	DE,HL
 	LD	DE,16
 	ADD	HL,DE
 	EX	DE,HL
 	PUSH	IY
 	POP	HL
 	LD	BC,40H
 	ADD	HL,BC
 	PUSH	HL
 	POP	IY
 	OR	A
 	RET
 MY	SCF
 	RET
 UPDATE	LD	A,(TYPE)
 	CP	1
 	JR	Z,UPDGO
 	CP	2
 	JR	Z,UPDISK
 FILAGN	LD	BC,(POSIT)
 	LD	DE,@FCB
 	CALL	@POSN
 	JP	NZ,FILERR
 	LD	HL,@BUFFER
 	CALL	@WRITE
 	CALL	NZ,BADWRT
 	JR	NZ,FILAGN
 	JP	FILELP
 CANCEL	LD	A,(TYPE)
 	CP	1
 	JR	Z,UPDGO
 	CP	2
 	JP	Z,DISKLP
 	JP	FILELP
 UPDGO	LD	HL,(VECTOR)
 	JP	(HL)
 UPDISK	LD	DE,(SECTOR)
 	LD	HL,@BUFFER
 	LD	A,(DRIVE)
 	LD	C,A
 	LD	A,0
 RDTYP	EQU	$-1
 	CP	6
 	JR	Z,PUTDIR
 	CP	7
 	JR	Z,PUTDIR
 	CALL	@WRSEC
 	JR	WRCONT
 PUTDIR	CALL	@WRSYS
 WRCONT	CALL	NZ,BADWRT
 	JR	NZ,UPDISK
 	JP	DISKLP
 HEXIT	XOR	A
 	JR	ITCONT
 BINIT	LD	A,2
 	JR	ITCONT
 OCTIT	LD	A,3
 	JR	ITCONT
 ASCIT	LD	A,4
 	JR	ITCONT
 DECIT	LD	A,1
 ITCONT	LD	(MODE),A
 	EX	DE,HL
 	LD	A,(TYPE)
 	CP	1
 	JP	Z,CONTMEM
 	CP	2
 	JP	Z,CONTDSK
 	JP	CONTFILE
 NUMBER	EX	DE,HL
 	PUSH	AF
 	LD	A,(MODE)
 	CP	4
 	JR	Z,ASCNUM
 	LD	HL,MODELN
 	SLA	A
 	LD	C,A
 	LD	B,0
 	ADD	HL,BC
 	LD	B,(HL)
 	INC	HL
 	LD	C,(HL)
 	POP	AF
 	LD	HL,STRING+1
 	JR	NUMHAV
 MODELN	DB	2,'H'
 	DB	3,'D'
 	DB	8,'B'
 	DB	3,'O'
 	DB	1,'A'
 ASCNUM	POP	AF
 NUMRET	LD	(DE),A
 	CALL	MODFIX
 	JP	MODR+1
 NUMON	LD	A,0B0H
 NUMOFF	LD	(IX),A
 	LD	(IX+1),A
 	LD	(IY),A
 	LD	A,12
 	LD	(NUMCNT),A
 NUMBLP	CALL	KBD
 	JR	NZ,NUMBHV
 	LD	A,0
 NUMCNT	EQU	$-1
 	LD	(NUMCNT),A
 	JR	NZ,NUMBLP
 	LD	A,(IX)
 	CP	0B0H
 	JR	NZ,NUMON
 	LD	A,20H
 	JR	NUMOFF
 NUMBHV	CALL	UCASE
 	CP	13
 	JR	Z,DECNUM
 	CP	30H
 	RET	C
 	CP	3AH
 	JR	C,NUMHAV
 	CP	'A'
 	RET	C
 	CP	'G'
 	RET	NC
 NUMHAV	LD	(HL),A
 	INC	HL
 	DJNZ	NUMON
 DECNUM	LD	(HL),13
 	LD	HL,STRING
 	LD	(HL),C
 	PUSH	DE
 	CALL	VALUE
 	POP	DE
 	RET	C
 	LD	A,C
 	JR	NUMRET
 FINDBYTE	CALL	CHMODTYPE
 	INC	HL
 FBON	LD	A,191
 	LD	(IX),A
 	LD	(IX+1),A
 	LD	(IY),A
 FBOFF	LD	A,50
 	LD	(FBCOUNT),A
 FBLP	CALL	KBD
 	JR	NZ,FBHAV
 	LD	A,0
 FBCOUNT	EQU	$-1
 	DEC	A
 	LD	(FBCOUNT),A
 	JR	NZ,FBLP
 	LD	A,(IX)
 	CP	191
 	JR	NZ,FBON
 	PUSH	HL
 	PUSH	BC
 	CALL	MODFIX
 	POP	BC
 	POP	HL
 	JR	FBOFF
 FBHAV	PUSH	AF
 	PUSH	BC
 	CALL	MODFIX
 	POP	BC
 	POP	AF
 	CP	'L'
 	JP	Z,LASTBYTE
 	CP	'l'
 	JP	Z,LASTBYTE
 	LD	(HL),A
 	CP	13
 	DEC	HL
 	JR	Z,FBDECN
 	INC	HL
 	DJNZ	FBON-1
 FBDECN	LD	A,(MODE)
 	CP	4
 	LD	A,(HL)
 	JR	Z,FBGO
 	INC	HL
 	LD	(HL),13
 	LD	HL,STRING
 	LD	(HL),C
 	PUSH	DE
 	CALL	VALUE
 	POP	DE
 	RET	C
 	LD	A,C
 FBGO	PUSH	AF
 	CALL	MODFIX
 	POP	AF
 	LD	(LASTB),A
 	LD	C,A
 	LD	A,(TEMP2)
 	LD	B,A
 	CP	0FFH
 	RET	Z
 	XOR	A
 	SUB	B
 	DEC	A
 	LD	B,A
 FIGO1	PUSH	BC
 	CALL	MODR+1
 	POP	BC
 	LD	A,(DE)
 	CP	C
 	RET	Z
 	DJNZ	FIGO1
 	RET
 LASTBYTE	LD	A,0
 LASTB	EQU	$-1
 	JR	FBGO
 INSBYTE	PUSH	HL
 	EX	DE,HL
 	LD	HL,(ADDRESS)
 	DEC	L
 	OR	A
 	SBC	HL,DE
 	LD	B,H
 	LD	C,L
 	LD	A,(TYPE)
 	CP	1
 	JR	Z,INSDOIT
 	LD	HL,200H
 	LD	B,H
 	LD	C,L
 	ADD	HL,DE
 	JR	INSDOITO
 INSDOIT	LD	HL,(ADDRESS)
 	DEC	L
 INSDOITO	LD	D,H
 	LD	E,L
 	DEC	HL
 	LDDR
 	POP	HL
 	LD	(HL),0
 	EX	DE,HL
 	JP	AASHOW
 DELBYTE	PUSH	HL
 	EX	DE,HL
 	LD	HL,(ADDRESS)
 	DEC	L
 	OR	A
 	SBC	HL,DE
 	LD	B,H
 	LD	C,L
 	POP	HL
 	PUSH	HL
 	LD	D,H
 	LD	E,L
 	INC	HL
 	LD	A,(TYPE)
 	CP	1
 	JR	Z,DELDOIT
 	LD	BC,200H
 DELDOIT	PUSH	AF
 	LDIR
 	POP	AF
 	POP	DE
 	JP	NZ,AASHOW
 	LD	HL,(ADDRESS)
 	DEC	L
 	LD	(HL),0
 	JP	AASHOW
 FILLBYTES	CALL	CHMODTYPE
 	INC	HL
 FILLON	LD	A,0B3H
 	PUSH	HL
 	LD	HL,0B7BBH
 	LD	(IX),H
 	LD	(IX+1),L
 	POP	HL
 	LD	(IY),A
 FILLOFF	LD	A,50
 	LD	(FLXXCNT),A
 FLBLP	CALL	KBD
 	JR	NZ,FLBHAV
 	LD	A,0
 FLXXCNT	EQU	$-1
 	DEC	A
 	LD	(FLXXCNT),A
 	JR	NZ,FLBLP
 	LD	A,(IY)
 	CP	0B3H
 	JR	NZ,FILLON
 	PUSH	HL
 	PUSH	BC
 	CALL	MODFIX
 	POP	BC
 	POP	HL
 	JR	FILLOFF
 FLBHAV	PUSH	AF
 	PUSH	BC
 	CALL	MODFIX
 	POP	BC
 	POP	AF
 	LD	(HL),A
 	CP	13
 	DEC	HL
 	JR	Z,FLBDECDN
 	INC	HL
 	DJNZ	FILLON-1
 FLBDECDN	LD	A,(MODE)
 	CP	4
 	LD	A,(HL)
 	JR	Z,FLGBO
 	INC	HL
 	LD	(HL),13
 	LD	HL,STRING
 	LD	(HL),C
 	PUSH	DE
 	CALL	VALUE
 	POP	DE
 	RET	C
 	LD	A,C
 	OR	A
 	RET	Z
 FLGBO	PUSH	AF
 	CALL	MODFIX
 	POP	AF
 	LD	C,A
 	LD	B,0
 	PUSH	DE
 	EX	DE,HL
 	LD	D,H
 	LD	E,L
 	INC	DE
 	LDIR
 	POP	DE
 	JP	AASHOW
 CHMODTYPE	EX	DE,HL
 	LD	HL,MODELN
 	LD	A,(MODE)
 	SLA	A
 	LD	C,A
 	LD	B,0
 	ADD	HL,BC
 	LD	B,(HL)
 	INC	HL
 	LD	C,(HL)
 	LD	HL,STRING
 	RET
 GOBYTE	CALL	CHMODTYPE
 	INC	HL
 GOBON	LD	A,5BH
 GOBOFF	LD	(IX),A
 	LD	(IX+1),A
 	LD	(IY),A
 	LD	A,20
 	LD	(GOBCNT),A
 GBLP	CALL	KBD
 	JR	NZ,GOBHAV
 	LD	A,0
 GOBCNT	EQU	$-1
 	DEC	A
 	LD	(GOBCNT),A
 	JR	NZ,GBLP
 	LD	A,(IX)
 	INC	A
 	CP	5FH
 	JR	C,GOBOFF
 	JR	GOBON
 GOBHAV	PUSH	AF
 	PUSH	BC
 	CALL	MODFIX
 	POP	BC
 	POP	AF
 	LD	(HL),A
 	CP	13
 	JR	Z,GOBDECN+1
 	CP	'L'
 	JR	Z,GOBLST
 	CP	'l'
 	JR	Z,GOBLST
 	DJNZ	GOBON-1
 GOBDECN	INC	HL
 	LD	(HL),13
 	LD	HL,STRING
 	LD	(HL),C
 	PUSH	DE
 	CALL	VALUE
 	POP	DE
 	RET	C
 	LD	A,C
 GOBGO	PUSH	AF
 	CALL	MODFIX
 	POP	AF
 	LD	IX,3C00H+8
 	LD	IY,3C00H+48
 	LD	DE,(ADDRESS)
 	LD	C,A
 	LD	(GBLST),A
 	OR	A
 	RET	Z
 GOBGO1	PUSH	BC
 	CALL	MODR+1
 	POP	BC
 	DEC	C
 	JR	NZ,GOBGO1
 	RET
 GOBLST	LD	A,0
 GBLST	EQU	$-1
 	JR	GOBGO
 CONTINUE2	CALL	1C9H
 	LD	A,(DRIVE)
 	LD	C,A
 	LD	A,(4)
 	CP	30H
 	JR	Z,CKIII
 	CALL	@CKDRV1
 	JR	CK1
 CKIII	CALL	@CKDRV3
 CK1	LD	A,11H
 	JP	NZ,ERROR
 	LD	A,(DRIVE)
 	LD	C,A
 	CALL	@GETDCT
 	LD	(IYSAVE),IY
 	JR	DISKLP
 DISDSK	LD	HL,TKMSG
 	CALL	@DISPLY
 	LD	B,31
 	LD	HL,STRING
 	CALL	@KEYIN
 	JP	C,EXIT
 	LD	A,B
 	OR	A
 	JP	Z,RESTART
 	XOR	A
 	LD	(TRACK),A
 	LD	(SECTOR),A
 	CALL	POSHL
 	JR	C,CONTINUE2
 	CP	':'
 	JR	NZ,CHKTRK
 	INC	HL
 	LD	A,(HL)
 	SUB	30H
 	JR	C,DISDSK
 	CP	8
 	JR	NC,DISDSK
 	LD	(DRIVE),A
 	INC	HL
 	CALL	POSHL
 	JR	C,CONTINUE2
 CHKTRK	CALL	VALUE
 	JR	C,DISDSK
 	LD	A,C
 	LD	(TRACK),A
 	CALL	POSHL
 	JR	C,CONTINUE2
 	CALL	VALUE
 	JR	C,DISDSK
 	LD	(SECTOR),A
 	JR	CONTINUE2
 DISKLP	CALL	ZBUFF
 	LD	HL,@BUFFER
 	LD	(ADDRESS),HL
 	LD	DE,0
 SECTOR	EQU	$-2
 TRACK	EQU	$-1
 	LD	A,(DRIVE)
 	LD	C,A
 	CALL	@RDSEC
 	LD	(RDTYP),A
 	JR	Z,GODISKX
 	CP	6
 	JR	Z,GODISKX
 	CP	7
 	JR	Z,GODISKX
 	CALL	NZ,BADRD
 	JR	NZ,DISKLP
 GODISKX	LD	HL,CONTDSK
 	LD	(VECTOR),HL
 CONTDSK	CALL	SHOW
 	CALL	FLKEY
 	CP	1
 	JP	Z,EXIT
 	CP	30H
 	JR	C,GOTTT
 	CP	3AH
 	JR	NC,GOTTT
 	SUB	30H
 	LD	(SECTOR),A
 	JP	DISKLP
 GOTTT	LD	IY,0
 IYSAVE	EQU	$-2
 	LD	HL,(SECTOR)
 	LD	DE,TABLE2
 	CALL	GOTABLE
 	JR	CONTDSK+3
 TABLE2	DB	'R'
 	DW	GOREST
 	DB	'X'
 	DW	RESTART
 	DB	'M'
 	DW	MODIFY
 	DB	'H'
 	DW	HEXIT
 	DB	'A'
 	DW	ASCIT
 	DB	'B'
 	DW	BINIT
 	DB	'D'
 	DW	DECIT
 	DB	'O'
 	DW	OCTIT
 	DB	5BH
 	DW	TRKUP
 	DB	10
 	DW	TRKDN
 	DB	8
 	DW	SECDN
 	DB	9
 	DW	SECUP
 	DB	18H
 	DW	BOTSEC
 	DB	19H
 	DW	TOPSEC
 	DB	1AH
 	DW	BOTTRK
 	DB	1BH
 	DW	TOPTRK
 	DB	31
 	DW	DISDSK
 	DB	'@'
 	DW	DIRTRK
 	DB	0
 BOTSEC	LD	L,0
 	JR	DSKRET
 TOPSEC	LD	A,(IY+7)
 	AND	1FH
 	LD	L,A
 	JR	DSKRET
 BOTTRK	LD	H,0
 	JR	DSKRET
 TOPTRK	LD	H,(IY+6)
 	JR	DSKRET
 DIRTRK	LD	H,(IY+9)
 	JR	DSKRET
 GOREST	LD	HL,0
 	JR	DSKRET
 TRKUP	LD	A,H
 	CP	(IY+6)
 	JR	Z,DSKRET
 	INC	H
 	JR	DSKRET
 TRKDN	LD	A,H
 	OR	A
 	JR	Z,DSKRET
 	DEC	H
 	JR	DSKRET
 SECUP	EX	DE,HL
 	CALL	NEXSEC
 	EX	DE,HL
 	JR	DSKRET
 SECDN	EX	DE,HL
 	CALL	BAKSEC
 	EX	DE,HL
 DSKRET	LD	(SECTOR),HL
 	JP	DISKLP
 AASHOW	PUSH	BC
 	PUSH	DE
 	PUSH	HL
 	PUSH	IX
 	PUSH	IY
 	CALL	SHOW
 	POP	IY
 	POP	IX
 	POP	HL
 	POP	DE
 	POP	BC
 	RET
 ZBUFF	LD	HL,@BUFFER
 	LD	DE,@BUFFER+1
 	LD	BC,0FFH
 	LD	(HL),0
 	LDIR
 	RET
 CONTINUE3	CALL	1C9H
 	LD	A,(DRIVE)
 	LD	C,A
 	CALL	@GETDCT
 	LD	(IYSAVE),IY
 	LD	HL,@BUFFER
 	LD	(ADDRESS),HL
 	LD	DE,@FCB
 	LD	A,(4)
 	CP	30H
 	JR	Z,LOFIII
 	CALL	@LOF1
 	JR	LOF1
 LOFIII	CALL	@LOF3
 LOF1	JP	NZ,FILERR
 	LD	(EOF),BC
 	LD	HL,CONTFILE
 	LD	(VECTOR),HL
 FILELP	CALL	ZBUFF
 	LD	DE,@FCB
 	LD	BC,0
 POSIT	EQU	$-2
 	CALL	@POSN
 	JP	NZ,FILERR
 	LD	HL,@BUFFER
 	CALL	@READ
 	CALL	NZ,BADRD
 	JR	NZ,FILELP
 	JR	CONTFILE
 FILERR	PUSH	AF
 	LD	HL,(POSIT)
 	LD	IX,PX1
 	CALL	WRLNO
 	LD	HL,(EOF)
 	LD	IX,PX2
 	CALL	WRLNO
 	LD	HL,FILEMSG
 	CALL	@DISPLY
 	POP	AF
 	OR	0C0H
 	CALL	@ERROR
 	LD	A,1
 	LD	(FLAGF),A
 	JR	CONTFILE+3
 CONTFILE	CALL	SHOW
 	CALL	FLKEY
 	CP	1
 	JP	Z,EXIT
 	PUSH	AF
 	LD	A,0
 FLAGF	EQU	$-1
 	OR	A
 	CALL	NZ,1C9H
 	XOR	A
 	LD	(FLAGF),A
 	POP	AF
 	LD	IY,(IYSAVE)
 	LD	BC,(POSIT)
 	LD	DE,TABLE3
 	CALL	GOTABLE
 	JR	CONTFILE+3
 TABLE3	DB	9
 	DW	UPFILE
 	DB	'X'
 	DW	RESTART
 	DB	5BH
 	DW	UPFILE
 	DB	8
 	DW	DOWNFILE
 	DB	10
 	DW	DOWNFILE
 	DB	'A'
 	DW	ASCIT
 	DB	'B'
 	DW	BINIT
 	DB	'D'
 	DW	DECIT
 	DB	'H'
 	DW	HEXIT
 	DB	'O'
 	DW	OCTIT
 	DB	'M'
 	DW	MODIFY
 	DB	18H
 	DW	BOTFILE
 	DB	19H
 	DW	TOPFILE
 	DB	1AH
 	DW	BOTFILE
 	DB	1BH
 	DW	TOPFILE
 	DB	31
 	DW	NEWFILE
 	DB	0
 DOWNFILE	LD	A,B
 	OR	C
 	JR	Z,FILRET
 	DEC	BC
 	JR	FILRET
 UPFILE	LD	HL,0
 EOF	EQU	$-2
 	OR	A
 	SBC	HL,BC
 	JR	Z,FILRET
 	INC	BC
 	JR	FILRET
 TOPFILE	LD	BC,(EOF)
 	JR	FILRET
 BOTFILE	LD	BC,0
 FILRET	LD	(POSIT),BC
 	JP	FILELP
 ;##
 HELP1	DB	10
 	DB	'aaaa      or',10
 	DB	'file1     or',10
 	DB	':b,c,d',10,10
 	DB	'aaaa   = memory address to display',10
 	DB	'file1  = file to display',10
 	DB	':b,c,d = Drive, Cylinder, Sector to display',10,13
 EXMSG	DB	1CH,1FH,'Power Modify * Terminated *',13
 FILEMSG	DB	1CH,1FH,10,'File Positioning Error!',10
 	DB	'Positioned to Sector '
 PX1	DB	'xxxxx, EOF Sector = '
 PX2	DB	'xxxxx.',13
 RELMSG	DB	'RSEC'
 EOFMSG	DB	'EOFS'
 FILMSG	DB	1CH,1FH,'Filespec ? ',3
 TKMSG	DB	1CH,1FH,'Drive, Cylinder, Sector ? ',3
 DVMSG	DB	'DRV'
 CYLMSG	DB	'CYL'
 SIDMSG	DB	'SID'
 SECMSG	DB	'SEC'
 STDMSG	DB	'STD'
 RPTMSG	DB	'RPT'
 DELMSG	DB	'DDT'
 FLPMSG	DB	'FLP'
 HRDMSG	DB	'RIG'
 WPMSG	DB	'SWP'
 NEWADD	DB	1CH,1FH
 	DB	'Address ? ',3
 CLRLIN	DB	1DH,1EH,3
 SMTMSG	DB	'Mount SYSTEM Disk.',3
 DMTMSG	DB	'Mount TARGET Disk.',3
 ASKBAD	DB	'R>etry, S>kip, or <BREAK> ? ',3
 BADRMSG	DB	1CH,1FH,'Disk READ Error !',13
 BADWMSG	DB	1CH,1FH,'Disk WRITE Error !',13
 ABMSG	DB	10,'* Aborted *',13
 PARMSG	DB	'Parameter Error !',13
 HELLO	DB	1CH,1FH
 	DB	'PMOD - LDOS Modification Utility - Version 1.0',10
 	DB	'by Kim Watt - (c)(p) 1982 Breeze/QSD, Inc.',10,10,13
 DRVMSG	DB	'Zap Parameters ? ',3
 DBUFF	EQU	$&0FF00H
 STRING	EQU	DBUFF+100H
 FILNAME	EQU	STRING+65
 @FCB	EQU	FILNAME+30
 GATBUFF	EQU	DBUFF+200H
 @BUFFER	EQU	GATBUFF+100H
 	ORG	@BUFFER
 WHO	DB	'* * * * * * * * * * * *',10
 	DB	'* Program by Kim Watt *',10
 	DB	'*     (c)(p) 1982     *',10
 	DB	'*   Breeze/QSD, Inc.  *',10
 	DB	'* 11500 Stemmons Fwy. *',10
 	DB	'*      Suite 125      *',10
 	DB	'* Dallas, Texas 75229 *',10
 	DB	'*   (214) 484-9428    *',10
 	DB	'* * * * * * * * * * * *',13
 	END	ENTRY
